<!doctype html>
<html>
<head>
<meta charset="utf-8">
<title>Documento sin título</title>
<style type="text/css">

.pixel{
	width:10px;
	height:10px;
	border-radius:10px;
	background-color:#FF0000;
	position:absolute;
	top:0px;
	left:0px;
}
	
.cursor{
	width:10px;
	height:10px;
	border-radius:10px;
	background-color:blue;
	position:absolute;
	top:0px;
	left:0px;
}

.lienzo{
	width:800px;
	height:600px;
	margin:10px auto;
	background-color:#666666;
	outline:1px solid #00FF00;
}
.lienzo>div{
	position:absolute;
}

.puntuacion{
	width:800px;
	height:40px;
	margin:10px auto;
	background-color:#666666;
	outline:1px solid #00FF00;
	font-size: 20px;
	line-height: 40px;
	text-align: center;
}

</style>
<script type="text/javascript">
<!--
this.g={};
g.tiempo=50;
g.paso=5;
g.pixel=new Array();
g.puntos=0;
g.direccion="derecha";
g.direcciones=new Array();

window.addEventListener("keydown",salta);
window.addEventListener("load",arranca);

var Punto=function(o,p){
	this.x;
	this.y;
	this.objeto;
	var sup=this;
	var paso;
	this.direccion;
	
	constructor(o,p);
	
	this.derecha=function(){
		this.x+=paso;
		this.objeto.style.left=this.x+"px";
	};
	
	this.izquierda=function(){
		this.x-=paso;
		this.objeto.style.left=this.x+"px";
	};
	
	this.arriba=function(){
		this.y-=paso;
		this.objeto.style.top=this.y+"px";
	};
	
	this.abajo=function(){
		this.y+=paso;
		this.objeto.style.top=this.y+"px";
	};
	
	this.setX=function(a){
		this.x=a;
		this.objeto.style.left=this.x+"px";
	}
	
	this.setY=function(a){
		this.y=a;
		this.objeto.style.top=this.y+"px";
	}
	
	function constructor(o,p){
		sup.objeto=document.createElement("div");
		sup.objeto.setAttribute("class","pixel");
		sup.objeto.style.left="10px";
		sup.objeto.style.top="10px";
		sup.x=10;
		sup.y=10;
		paso=p;
		o.appendChild(sup.objeto);
		sup.direccion=0;
	};
	
	
};
	
var Comida=function(o){
	this.x;
	this.y;
	this.objeto;
	var sup=this;
	
	this.nuevo=function(){
		this.x=Math.floor(Math.random()*200);
		this.y=Math.floor(Math.random()*200);
		this.objeto.style.left=this.x+"px";
		this.objeto.style.top=this.y+"px";
	};
	
	function constructor(o){
		sup.objeto=document.createElement("div");
		sup.x=Math.floor(Math.random()*200);
		sup.y=Math.floor(Math.random()*200);
		sup.objeto.style.left=sup.x+"px";
		sup.objeto.style.top=sup.y+"px";
		o.appendChild(sup.objeto);
		sup.objeto.setAttribute("class","cursor");
	};
	constructor(o);
}
	
	
function salta(){
	switch(event.keyCode){
		case 38:
			g.direccion="arriba";
			break;
		case 40:
			g.direccion="abajo";
			break;
		case 39:
			g.direccion="derecha";			
			break;
		case 37:
			g.direccion="izquierda";
			break;
	}
}

function f1(){
	
	g.direcciones.unshift(g.direccion);
	g.direcciones.pop(g.direccion);
	for(c=0;c<=g.puntos;c++){
		g.pixel[c].direccion=g.direcciones[c];
	}
		
	for(c=0;c<=g.puntos;c++){
		switch(g.pixel[c].direccion){
			case "arriba":
				g.pixel[c].arriba();
				break;
			case "abajo":
				g.pixel[c].abajo();
				break;
			case "derecha":
				g.pixel[c].derecha();
				break;
			case "izquierda":
				g.pixel[c].izquierda();
				break;
		}
	}
	
	comprobarColision();
	comprobarSubirNivel();
	
}


function comprobarColision(){
	if(!(g.pixel[0].x<(790+g.paso) && g.pixel[0].y<(590+g.paso) && g.pixel[0].x>=0 && g.pixel[0].y>=0)){
		clearInterval(g.intervalo);
	}
	
}
	
function comprobarSubirNivel(){
	if(g.pixel[g.puntos].x>g.cursor.x && g.pixel[g.puntos].x<(g.cursor.x+10) && g.pixel[g.puntos].y>g.cursor.y && g.pixel[g.puntos].y<(g.cursor.y+10)){
		g.cursor.nuevo();
		g.puntos++;
		document.querySelector(".puntuacion").innerHTML=g.puntos;
		g.pixel[g.puntos]=new Punto(document.querySelector(".dibujar"),g.paso);
		g.pixel[g.puntos].direccion=g.pixel[g.puntos-1].direccion;
		g.direcciones[g.puntos]=g.pixel[g.puntos-1].direccion;
		g.pixel[g.puntos].setX(g.pixel[g.puntos-1].x);
		g.pixel[g.puntos].setY(g.pixel[g.puntos-1].y);
		
		
		switch(g.pixel[0].direccion){
		case "arriba":
			g.pixel[g.puntos].abajo();
			g.pixel[g.puntos].setY(g.pixel[g.puntos].y);	
			break;
		case "abajo":
			g.pixel[g.puntos].arriba();
			g.pixel[g.puntos].setY(g.pixel[g.puntos].y);	
			break;
		case "derecha":
			g.pixel[g.puntos].izquierda();
			g.pixel[g.puntos].setX(g.pixel[g.puntos].x);					
			break;
		case "izquierda":
			g.pixel[g.puntos].derecha();
			g.pixel[g.puntos].setX(g.pixel[g.puntos].x);	
			break;
		}
	}
}
	
function arranca(){
	g.pixel[0]=new Punto(document.querySelector(".dibujar"),g.paso);
	g.pixel[0].direccion="derecha";
	g.direcciones[0]="derecha";
	g.cursor=new Comida(document.querySelector(".dibujar"));
	g.intervalo=setInterval(f1,g.tiempo);	
}



//-->
</script>

</head>

<body>
<div class="lienzo">
<div class="dibujar">
</div>
</div>
<div class="puntuacion">
	0
</div>
</body>
</html>
